'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
OBJ
  sys : "sysdefs"
  'ser : "cserial"
  
CON
  pFileCommand = sys#filecmd
  pFileParms   = sys#fileparm

PRI RemoteFunctionCall(funcnum, pArgList) | locknum
  locknum := long[sys#filelock]
  repeat until not lockset(locknum - 1)
  long[pFileParms] := pArgList
  long[pFileCommand] := (cogid << 16) | funcnum 
  repeat while long[pFileCommand]
  result := long[pFileParms]
  lockclr(locknum - 1)

PUB fgetc(stream)
  result := RemoteFunctionCall(1, @stream)

PUB fgets(str, num, stream)
  result := RemoteFunctionCall(2, @str)

PUB fopen(fname, mode)
  result := RemoteFunctionCall(3, @fname)

PUB fread(buffer, elem_size, num, stream)
  result := RemoteFunctionCall(4, @buffer)

PUB fwrite(buffer, elem_size, num, stream)
  result := RemoteFunctionCall(5, @buffer)

PUB fclose(stream) | file_data
  result := RemoteFunctionCall(6, @stream)

PUB remove(fname)
  result := RemoteFunctionCall(7, @fname)
    
PUB rename(fname1, fname2)
  result := RemoteFunctionCall(8, @fname1)

PUB create(fname)
  result := RemoteFunctionCall(9, @fname)

PUB getfilesize(stream)
  result := RemoteFunctionCall(10, @stream)

PUB mount_explicit(DO, CLK, DI, CS)
  result := RemoteFunctionCall(11, @DO)

PUB getcwd(str, num)
  result := RemoteFunctionCall(12, @str)

PUB chdir(path)
  result := RemoteFunctionCall(13, @path)

PUB format(size)
  result := RemoteFunctionCall(14, @size)

PUB opendir(path)
  result := RemoteFunctionCall(15, @path)

PUB readdir(stream)
  result := RemoteFunctionCall(16, @stream)

PUB closedir(stream)
  result := RemoteFunctionCall(17, @stream)

PUB ftell(stream)
  result := RemoteFunctionCall(18, @stream)

PUB fseek(stream, position, origin)
  result := RemoteFunctionCall(19, @stream)

PUB fflush(stream)
  result := RemoteFunctionCall(20, @stream)

PUB mkdir(fname)
  result := RemoteFunctionCall(21, @fname)

PUB chmod(fname, modebits)
  result := RemoteFunctionCall(22, @fname)

PUB getmod(fname)
  result := RemoteFunctionCall(23, @fname)

PUB run(argc, argv, cognum1)
  result := RemoteFunctionCall(24, @argc)

PUB kill(cognum)
  result := RemoteFunctionCall(25, @cognum)

PUB runc(argc, argv, cognum1)
  'ser.str(string("cfile_os: runc", 13))
  result := RemoteFunctionCall(26, @argc)
{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
